{

------------------------------------------------------------------
            TDiskEject Component for Delphi
------------------------------------------------------------------
(c) 1999 Daniel Polistchuck
Windows NT (v. 4.0 SP3) testing and corrections by Pawel Michalowski

ZIP AND JAZ Disks & Drives are copyrighted by IOMEGA
Sparq and SyJet Disks & Drives are Copyright by SyQuest
------------------------------------------------------------------
This source code is freeware, feel free to use it as
you wish - either commercially or not. The author shall
not be held responsible for any damage made by the use
or misuse of this software material.

Please, if any changes or corrections are made, send
me a copy at danpol@pobox.com.
------------------------------------------------------------------
Observations:
-Ejects Removable disks (ZIP,JAZ,Sparq, SyJet, etc. plus any CD-Roms)
-Um abrao para a galera Delphizera do Brasil!
 (this is in portuguese and is a salute to the Delphi programmers
  from Brazil).
- Niech zyja Polscy programerzy Delphi!
 (this is in Polish and is a salute to the Delphi programmers from Poland).
- Tested on Windows NT 4.0 SP3
- While manipulating in design-time the Ejected property in
  the Object Inspector will only reflect the true state of
  the disk if you de-select then reselect the property after
  changing it from false to true. THIS PROBLEM OCCURS ONLY IN
  DESIGN-TIME, TOUGH.
------------------------------------------------------------------
Version history:
v1.2 - some code cleanup. Got rid of hints <g>  by Daniel Polistchuk
v1.1 - maintenance release of version 1.0 - Windows NT 4.0 SP3 testing
	 and corrections by Pawel Michalowski (pawelmic@ottawa.com)
v1.0 - first public release

}
unit DiskEject;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;


type
  EDiskEject = class (Exception);
  TDiskEject = class(TComponent)
  private
    { Private declarations }
    FDrive : Char;
    function GetEjected : Boolean;
    procedure SetEjected (Value : Boolean);
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure Eject;
  published
    { Published declarations }
    property Drive : Char read FDrive write FDrive;
    property Ejected : Boolean read GetEjected write SetEjected stored false;
  end;

procedure Register;

//{$R *.dcr}

implementation

uses WinIoCtl;

function IsDiskInDrive (Drive : Char) : Boolean;
var
  a,b,c,d: Cardinal;
begin
  Result := GetDiskFreeSpace(PChar(Drive+':\'),a,b,c,d);
end;

function EjectRemovableDrive (Drive : Char) : Boolean;
var
   reg: DEVIOCTL_REGISTERS;
   hDevice: THandle;
   cb: DWORD;
   lpFileName: PChar;
begin
     if Win32Platform = VER_PLATFORM_WIN32_WINDOWS then
     begin
          reg.reg_EAX := $440D;       //* IOCTL for block devices */
          reg.reg_EBX := Ord(UpCase(Drive))-Ord ('A')+1;       //* zero-based drive ID     */
          reg.reg_ECX := MakeWOrd($49,8);

          if (not Win95IOCTL(@reg)) then
          begin
               result := FALSE;
               exit;
          end;

          if (reg.reg_Flags and $0001) <> 0 then //* error if carry flag set */
          begin
               result := FALSE;
               exit;
          end;
          Result := True;
     end
     // Windows NT (4.0 SP3) testing and corrections by Pawel Michalowski
     else if Win32Platform = VER_PLATFORM_WIN32_NT then
     begin
          // Using a variable assignment with lpFileName allows you to debug the
	    // value you passed as 'Drive'.  Usually due to optimization this value
	    // would be inaccessible. (PM)

          lpFileName := PChar('\\.\'+UpperCase(Drive)+':');

	    // When getting the device handle in a call to CreateFile you have to
	    // use GENERIC_READ (0 won't work) and FILE_ATTRIBUTE_NORMAL (again 0
	    // won't work) (PM)

          hDevice := CreateFile(lpFileName,
          GENERIC_READ{0}, FILE_SHARE_READ or FILE_SHARE_WRITE,
          nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL{0}, 0);

          if hDevice = INVALID_HANDLE_VALUE{0} then
          begin
               Result := False;
               Exit;
          end;
          Result := DeviceIoControl(hDevice,
          IOCTL_DISK_EJECT_MEDIA , nil, 0,
          nil,0, cb, nil);

          CloseHandle(hDevice);
     end
     else
         Raise EDiskEject.Create ('Operating System not supported!');
end;

procedure TDiskEject.Eject;
begin
  if not EjectRemovableDrive (FDrive) then
    raise EDiskEject.Create ('Could not eject disk!');
end;

function TDiskEject.GetEjected : Boolean;
begin
  Result := not IsDiskInDrive (FDrive);
end;

procedure TDiskEject.SetEjected(Value : Boolean);
begin
  if Value then
    if not Ejected then
      Eject
    else
      raise EDiskEject.Create ('No disk in drive!');
end;

procedure Register;
begin
  RegisterComponents('QualTech', [TDiskEject]);
end;

end.
